//========================================================================================
//
//	File:				CEExtnsn.cpp
//	Release Version:	$ ODF 2 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#define CE_OColorExtension_Class_Source

#include "CEExtnsn.xih"

#ifndef FWODFEXC_H
#include "FWODFExc.h"
#endif

#ifndef SOM_ODPart_xh
#include "Part.xh"
#endif

//========================================================================================
//	class CE_OColorExtension
//========================================================================================

//----------------------------------------------------------------------------------------
//	CE_OColorExtension::InitColorExtension
//----------------------------------------------------------------------------------------

SOM_Scope void  SOMLINK CE_OColorExtension__InitColorExtension(CE_OColorExtension *somSelf, Environment *ev,
		ODPart* base,
		somToken refCon,
		CE_HColorExtensionProcGlue colorExtensionProcGlue)
{
    CE_OColorExtensionData *somThis = CE_OColorExtensionGetData(somSelf);
    CE_OColorExtensionMethodDebug("CE_OColorExtension","CE_OColorExtension__InitColorExtension");
	
	somThis->fRefCon = refCon;
	somThis->fColorExtensionProcGlue = colorExtensionProcGlue;
    
    somSelf->InitExtension(ev, base);
}

//----------------------------------------------------------------------------------------
//	CE_OColorExtension::SetForegroundColor
//----------------------------------------------------------------------------------------

SOM_Scope void  SOMLINK CE_OColorExtension__SetForegroundColor(CE_OColorExtension *somSelf, Environment *ev,
		short red,
		short green,
		short blue)
{
    CE_OColorExtensionData *somThis = CE_OColorExtensionGetData(somSelf);
    CE_OColorExtensionMethodDebug("CE_OColorExtension","CE_OColorExtension__SetForegroundColor");
	
	if (somSelf->IsValid(ev))
    	(somThis->fColorExtensionProcGlue->_fForeColorProcGlue)(ev, somThis->fRefCon, red, green, blue);
    else
    	FW_SetEvError(ev, kODErrInvalidExtension);
}

//----------------------------------------------------------------------------------------
//	CE_OColorExtension::SetBackgroundColor
//----------------------------------------------------------------------------------------

SOM_Scope void  SOMLINK CE_OColorExtension__SetBackgroundColor(CE_OColorExtension *somSelf, Environment *ev,
		short red,
		short green,
		short blue)
{
    CE_OColorExtensionData *somThis = CE_OColorExtensionGetData(somSelf);
    CE_OColorExtensionMethodDebug("CE_OColorExtension","CE_OColorExtension__SetBackgroundColor");

    if (somSelf->IsValid(ev))
   		(somThis->fColorExtensionProcGlue->_fBackColorProcGlue)(ev, somThis->fRefCon, red, green, blue);
   	else
   		FW_SetEvError(ev, kODErrInvalidExtension);
}

//----------------------------------------------------------------------------------------
//	CE_OColorExtension::Release
//----------------------------------------------------------------------------------------

SOM_Scope void  SOMLINK CE_OColorExtension__Release(CE_OColorExtension *somSelf, Environment *ev)
{
    CE_OColorExtensionData *somThis = CE_OColorExtensionGetData(somSelf);
    CE_OColorExtensionMethodDebug("CE_OColorExtension","CE_OColorExtension__Release");

	FW_Boolean isValid = somSelf->IsValid(ev);
	
    CE_OColorExtension_parent_ODExtension_Release(somSelf,ev);
    
    if (!isValid && somSelf->GetRefCount(ev) == 0)
    	delete somSelf;
}
